<template>
  <div class="kurs">
    <h3>Kurs Pajak</h3>
    <div class="card mt-5">
      <div class="card-header">
        Kurs List
      </div>
      <div class="card-body">
        <div class="table-responsive">
          <table class="table">
            <thead>
              <tr>
                <th scope="col">
                  No
                </th>
                <th>
                  Mata Uang
                </th>
                <th>
                  Nilai
                </th>
                <th>
                  Perubahan
                </th>
                <th>
                  Action
                </th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="kurs in sortedKurs" v-bind:key="kurs.id">
                <template v-if="editId == kurs.id">
                  <td>{{kurs.no}}</td>
                  <td><input v-model="editKursData.currency" type="text"></td>
                  <td><input v-model="editKursData.value" type="text"></td>
                  <td><input v-model="editKursData.shift" type="text"></td>
                  <td>
                    <button class="btn btn-success" @click="onEditSubmit(kurs.id)">Ok</button>
                    <button class="btn btn-secondary" @click="onReset">Cancel</button>                  
                  </td>
                </template>
                <template v-else>
                  <td>
                    {{kurs.no}}
                  </td>
                  <td>
                    {{kurs.currency}}
                  </td>
                  <td>
                    {{kurs.value}}
                  </td>
                  <td>
                    {{kurs.shift}}
                  </td>
                  <td>

                    <button class="btn btn-primary" @click="onEdit(kurs)">Edit</button>
                    <router-link 
                      :to="{
                        name:'KursPage', 
                        params:{id: kurs.id}
                      }" 
                      class="btn">
                      <button class="btn btn-danger">View</button>
                    </router-link>
                  </td>
                </template>
              </tr>

            </tbody>
          </table>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import axios from 'axios'
export default {
  name: 'app',
    data() {
        return {
            editId: '',
            kursData: {
              'id': '',
              'no' : '',
              'currency': '',
              'value': '',
              'shift': ''
            },
            editKursData: {
              'id': '',
              'no' : '',
              'currency': '',
              'value': '',
              'shift': ''
            },
            kurs: []
        }
    },
    created() {
      this.getKurs()
    },
    computed:{
      sortedKurs(){
        return this.kurs.slice().sort((a,b)=>{
          return a.no - b.no
        })
      }
    },
    methods: {
      getKurs() {
        axios.get('http://localhost:8000/api/v1/kurs', {
          headers: {
            'Content-Type': 'application/json',
            'Authorization': '88HEAD '+sessionStorage.getItem('token')
          }
        })
        .then(response => {
          this.kurs = response.data
        })
        .catch(e => {
          console.log(e.response)
        })
      },
      onEdit(kurs){
        this.editId = kurs.id
        this.editKursData.id = kurs.id
        this.editKursData.no = kurs.no
        this.editKursData.currency = kurs.currency
        this.editKursData.value = kurs.value
        this.editKursData.shift = kurs.shift
      },
      onReset(){
        this.editId = ''
        this.editKursData.id = ''
        this.editKursData.no = ''
        this.editKursData.currency = ''
        this.editKursData.value = ''
        this.editKursData.shift = ''
      },
      onEditSubmit (id){
        axios.put('http://localhost:8000/api/v1/kurs/'+id+'/', this.editKursData, {
          headers: {
            'Content-Type': 'application/json',
            'Authorization': '88HEAD '+sessionStorage.getItem('token')
          }
        })
        .then(response => {
          this.getKurs()
          this.onReset()
        })
        .catch(e => {
          console.log(e.response)
        })
      }
    }
  }
</script>

<style scoped>
h3{
  text-align: center;
  margin-top: 30px;
  margin-bottom: 20px;
}
.icon{
  margin-right: 10px;
}
.icon i{
  cursor: pointer;
}
</style>
